`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 		 D.A. Heitman
// 
// Create Date:    20:49:07 02/14/2011 
// Design Name: 
// Module Name:    ClockGenerator 
// Project Name: 
// Target Devices: Xylo-lm
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
module ClockGenerator(
    input FX2_CLK,
    input Reset,
    input LoadClock,
    input [31:0] Data,
	 output reg mClk
    );
	 
wire tClk;
wire clk0;
DCM_SP DCM_SP_inst( .CLKIN(FX2_CLK), .CLK0(clk0),.CLKFB(clk0),.CLKFX(tClk));
defparam DCM_SP_inst.CLKFX_MULTIPLY = 25;
defparam DCM_SP_inst.CLKFX_DIVIDE = 3;

reg[15:0] ClkMpr = 1; 
reg[15:0] ClkCt=0;

always @(posedge tClk or posedge Reset)
	if(Reset) begin
		ClkCt<=0;
		mClk<=1'b0;
		end
	else if(LoadClock)begin
		ClkMpr<=Data[15:0];
		end
	else if(ClkCt>=ClkMpr) begin
		mClk<=~mClk;
		ClkCt<=1;
		end
	else
		ClkCt<=ClkCt+1;
		
endmodule
