`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 		 D.A. Heitman
// 
// Create Date:    21:44:25 02/14/2011 
// Design Name: 
// Module Name:    Controller 
// Project Name: 
// Target Devices: Xylo-lm
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

     is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
module Controller(
    input mClk,
    input Reset,
    input LoadPreAmble,
	 input[31:0] Data,
    input Armed,
    input Fired,
	 input[15:0] Channel,
    output reg [13:0] Mem_Addr,
    output reg Mem_Wr,
	 output reg [15:0] Mem_Data
    );

reg[1:0] cntState=0,cntState_next=0;
reg[13:0] Mem_Addr_next=0;
reg[13:0] LastAddr=0;
reg[13:0] PreAmble=10;
reg LoadStart=0,LoadStart_next=0;

always @(posedge mClk) begin
	if(LoadPreAmble)
		PreAmble<=Data[13:0];
	end
always @(posedge mClk or posedge Reset) begin
	if(Reset) begin
		cntState<=0;
		Mem_Addr_next<=0;
		end
	else begin 
		cntState<=cntState_next;
		LoadStart<=LoadStart_next;
		if(Mem_Wr)
			Mem_Addr_next<=Mem_Addr+1;
		else
			Mem_Addr_next<=Mem_Addr;
		end
	end	
always @* begin
	cntState_next=cntState; 
	Mem_Wr=0;
	LoadStart_next=0;
	case(cntState)
	default:cntState_next=0;
	0: if(Armed) begin Mem_Wr=1;cntState_next=1;end
	1: if(!Armed) cntState_next=0;
		else begin
			Mem_Wr=1;
			if(Fired) begin cntState_next=2;LoadStart_next=1;end
			end
	2: if(!Fired) cntState_next=0;
		else
			if(Mem_Addr!=LastAddr) Mem_Wr=1;
	endcase
	end
always @(negedge mClk)begin
	if(LoadStart)
		LastAddr<=Mem_Addr-PreAmble;
	Mem_Addr<=Mem_Addr_next;
	Mem_Data<=Channel;
	end
		

endmodule
