`timescale 1 ns/10 ps
module Controller_tb();

localparam  T=10; // clock period
reg mClk, Reset;

reg LoadPreAmble=0;
reg[15:0] Data=0;
reg Armed=0,Fired=0;
wire[13:0] Mem_Addr;
wire Mem_Wr;

Controller cnt1(mClk,Reset,LoadPreAmble,Data,Armed,Fired,
	Mem_Addr,Mem_Wr);

   // clock
   // 10 ns clock running forever
   always
   begin
      mClk = 1'b1;
      #(T/2);
      mClk = 1'b0;
      #(T/2);
   end

   // reset for the first half cycle
   initial
   begin
     Reset = 1'b1;
     #(T/2); 
     Reset = 1'b0;
   end

initial
begin

	#(T*4);
	Data=4;
	LoadPreAmble=1;
	#T;
	LoadPreAmble=0;
	#(T*4);
	Armed=1;
	#(T*10);
	Fired=1;
	#(T*10);
	Armed=0;Fired=0;
	#(T*2);
	$stop;
end

	
endmodule