`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 		 D.A. Heitman
// 
// Create Date:    20:14:18 02/14/2011 
// Design Name: 
// Module Name:    Core 
// Project Name: 
// Target Devices: Xylo-lm
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
module Core(
    input mClk,
    input Reset,
    input Execute,
    input [7:0] Cmd,
    input [31:0] Data,
    input [15:0] Channel,
	 output ResetCmd,
	 output LoadClock,
    output [13:0] Mem_Addr,
    output [15:0] Mem_Data,
    output Mem_Wr,
	 output Armed,
	 output Fired,
	 output[5:0] Status
    );

wire[5:0] trgStatus;
//assign Status={4'b0,Armed,Fired};
assign Status=trgStatus;
wire LoadPreAmble,SetMask12,SetMask34,SetValue12,SetValue34,SetStart,Arm;

DecodeCmd LA_Decode(mClk,Reset,Execute,Cmd,
	ResetCmd,LoadClock,LoadPreAmble,SetMask12,SetMask34,SetValue12,SetValue34,SetStart,Arm);

Trigger LA_Trigger(mClk,Reset,SetMask12,SetMask34,SetValue12,SetValue34,SetStart,Data,
	Arm,Armed,Fired,
	Channel,trgStatus);

Controller LA_controller(mClk,Reset,LoadPreAmble,Data,Armed,Fired,
	Channel,Mem_Addr,Mem_Wr,Mem_Data);

endmodule
