`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 		 D.A. Heitman
// 
// Create Date:    21:17:36 02/14/2011 
// Design Name: 
// Module Name:    DecodeCmd 
// Project Name: 
// Target Devices: Xylo-lm
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
module DecodeCmd(
    input mClk,
    input Reset,
	 input Execute,
    input [7:0] Cmd,
    output reg ResetCmd,
	 output reg LoadClock,
	 output reg LoadPreAmble,
    output reg SetMask12,
    output reg SetMask34,
    output reg SetValue12,
    output reg SetValue34,
	 output reg SetStart,
    output reg Arm
    );


reg dcState,dcState_next;
always @(posedge mClk or posedge Reset)
	if(Reset)
		dcState<=0;
	else
		dcState<=dcState_next;
always @* begin
	dcState_next=dcState;
	ResetCmd=0;
	LoadClock=0;
	LoadPreAmble=0;
	SetMask12=0;
	SetMask34=0;
	SetValue12=0;
	SetValue34=0;
	SetStart=0;
	Arm=0;
	case(dcState)
	0: if(Execute) begin
			dcState_next=1;
			end
	1: begin
			dcState_next=0;
			case(Cmd)
		// 1: Read data from Memory
		//	2:	Read Status: Armed,Fired,Memory address
			3: ResetCmd=1;
			4: LoadClock=1;
			5: LoadPreAmble=1;
			6: SetMask12=1;
			7: SetMask34=1;
			8: SetValue12=1;
			9: SetValue34=1;
			14: SetStart=1;
			15: Arm=1;
			endcase
		end
	endcase
	end
endmodule
