`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 		 D.A. Heitman
// 
// Create Date:    20:17:26 02/14/2011 
// Design Name: 
// Module Name:    LogicAnalyzer 
// Project Name: 
// Target Devices: Xylo-lm
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
module LogicAnalyzer(
    input FX2_CLK,
    inout [7:0] FX2_FD,
    output FX2_SLRD,
    output FX2_SLWR,
    input [0:0] FX2_FLAGS,
    output FX2_PA_2,
    output FX2_PA_3,
    output FX2_PA_4,
    output FX2_PA_5,
    output FX2_PA_6,
//    input FX2_PA_7,

	 inout[15:0] Channel_in,
	 output[1:0]LED
    );

wire [7:0] Cmd;
wire [31:0] Data;
wire [13:0] Mem_wAddr;
wire [13:0] Mem_rAddr;
wire [15:0] Mem_wData;
wire [15:0] Mem_rData;
reg[15:0] Channel;

wire mClk,Reset,Execute,ResetCmd,LoadClock,Mem_Wr,Armed,Fired;
wire[5:0]UsbStatus;
wire[5:0]CoreStatus;
wire[15:0] LaStatus = {Mem_Wr,Fired&!Armed,Mem_wAddr};
//Display dsp(FX2_CLK,UsbStatus,LED);
Display dsp(FX2_CLK,CoreStatus,LED);

ClockGenerator LA_clk(FX2_CLK,Reset,LoadClock,Data,mClk/*,LEDd*/);

always @(posedge mClk) begin
	Channel=Channel_in;
	end

UsbCmd	LA_Usb(FX2_CLK,FX2_FD,FX2_SLRD,FX2_SLWR,FX2_FLAGS,FX2_PA_2,FX2_PA_3,FX2_PA_4,FX2_PA_5,FX2_PA_6,//FX2_PA_7,
			mClk,Reset,Execute,Cmd,Data,Mem_rAddr,Mem_rData,LaStatus,UsbStatus);

Core		LA_Core(mClk,Reset,Execute,Cmd,Data,Channel,ResetCmd,LoadClock,Mem_wAddr,Mem_wData,Mem_Wr,Armed,Fired,CoreStatus);

assign Reset = ResetCmd;

Memory	LA_Mem(mClk,Mem_Wr,Mem_wAddr,Mem_rAddr,Mem_wData,Mem_rData);


endmodule
