`timescale 1 ns/10 ps
module Trigger_tb();

localparam  T=80; // clock period
reg mClk, Reset;

reg SetMask12 = 0;
reg SetMask34 = 0;
reg SetValue12 = 0;
reg SetValue34 = 0;
reg SetStart = 0;
reg[31:0] Data = 0;
reg Arm = 0;
wire Armed,Fired;
reg[15:0] Channel = {14'b11111111111111,2'b01};

Trigger Trg1(mClk,Reset,SetMask12,SetMask34,SetValue12,SetValue34,SetStart,Data,
	Arm,Armed,Fired,
	Channel);


   // clock
   // 80 ns clock running forever
   always
   begin
      mClk = 1'b1;
      #(T/2);
      mClk = 1'b0;
      #(T/2);
   end

   // reset for the first half cycle
   initial
   begin
     Reset = 1'b1;
     #(T/2); 
     Reset = 1'b0;
   end

initial
begin

	#(T*3);
	Data=32'h00030003;
	SetMask12=1;
	#(T);
	SetMask12=0;
	#(T*3);
	Data=32'h00030003;
	SetMask34=1;
	#(T);
	SetMask34=0;
	#(T*3);
	Data=32'h00010003;
	SetValue12=1;
	#(T);
	SetValue12=0;
	#(T*3);
	Data=32'h00020002;
	SetValue34=1;
	#(T);
	SetValue34=0;
	#(T*3);
	Data=8'b00000001;
	SetStart=1;
	#(T);
	SetStart=0;
	#(T*3);
	Arm=1;
	#(T);
	Arm=0;
	#(T*4);
	Channel={14'b11111111111111,2'b00};
	#(T*3);
	Channel={14'b11111111111111,2'b01};
	#(T*3);
	Channel={14'b11111111111111,2'b10};
	#(T*3);
	Channel={14'b11111111111111,2'b11};
	#(T*3);
	Channel={14'b11111111111111,2'b00};
	#(T*3);
	Channel={14'b11111111111111,2'b01};
	#(T*3);
	Channel={14'b11111111111111,2'b10};
	#(T*3);
	Channel={14'b11111111111111,2'b11};
	#(T*3);
	Channel={14'b11111111111111,2'b00};
	#(T*3);
	Channel={14'b11111111111111,2'b01};
	#(T*3);
	Channel={14'b11111111111111,2'b10};
	#(T*3);
	Channel={14'b11111111111111,2'b11};
	#(T*3);
	Reset=1'b1;
	#(T)
	Reset=1'b0;
	#(T*3)
			$stop;
end

	
endmodule