`timescale 1 ns/10 ps
module Core_tb();

localparam  T=10; // clock period
reg mClk, Reset;

reg LoadPreAmble=0;
wire LoadClock,ResetCmd;
reg[15:0] Data=0;
wire Armed,Fired;
wire[13:0] Mem_wAddr;
wire[15:0] Mem_wData;
wire Mem_Wr;

reg[7:0] Cmd=0;
reg[15:0] Channel=0;
reg Execute=0;

Core		Core1(mClk,Reset,Execute,Cmd,Data,Channel,ResetCmd,LoadClock,Mem_wAddr,Mem_wData,Mem_Wr,Armed,Fired);

   // clock
   // 10 ns clock running forever
   always
   begin
      mClk = 1'b1;
      #(T/2);
      mClk = 1'b0;
      #(T/2);
   end

   // reset for the first half cycle
   initial
   begin
     Reset = 1'b1;
     #(T/2); 
     Reset = 1'b0;
   end

initial
begin

	#(T*4);
	Data=4;
	Cmd=4;
	Execute=1;
	#T;
	Execute=0;
	#T;
	Data=1;
	Cmd=6;
	Execute=1;
	#T;
	Execute=0;
	#T;
	Data=1;
	Cmd=7;
	Execute=1;
	#T;
	Execute=0;
	#T;
	Cmd=8;
	Execute=1;
	#T;
	Execute=0;
	#(T*10);
	Channel=1;
	#(T*10);
	$stop;
end

	
endmodule