// LAInfo.h : implmentation of the CLAinfo class
//
/////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "StdAfx.h"
#include "LAInfo.h"

CLAInfo::CLAInfo(void)
{
	for(int i=0;i<16;++i) {Channel[i]=true;Mhz[i]=0;}
}

CLAInfo::~CLAInfo(void)
{
}
LRESULT CLAInfo::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	return 0;
}
LRESULT CLAInfo::OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
TCHAR buf[100];
	DoDataExchange(FALSE);
	for(int i=0;i<16;++i)
	{
		if(Mhz[i]==0 || !Channel[i]) ::SetWindowText(GetDlgItem(IDC_MHZ0+i),_T(""));
		else 
		{
			double tm=1000/Mhz[i];
			if(tm<1000)
				_stprintf(buf,_T("%3.2f ns/%3.2f Mhz"),tm,Mhz[i]);
			else 
			{
				tm/=1000;
				_stprintf(buf,_T("%3.2f us/%3.2f Khz"),tm,Mhz[i]*1000);
			}
			::SetWindowText(GetDlgItem(IDC_MHZ0+i),buf);
		}
	}
	bHandled=FALSE;
	return 0;
}
LRESULT CLAInfo::OnParentNotify(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return 0;
}
LRESULT CLAInfo::OnNotify(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	
	NMHDR * pNmHdr = (NMHDR *) lParam;
	switch(pNmHdr->code)
	{
	case BN_CLICKED: 
		if(pNmHdr->idFrom-IDC_CHANNEL0>=0 &&pNmHdr->idFrom-IDC_CHANNEL0<16)
			int xyzzy=1;
		break;
	}

	return 0;
}
LRESULT CLAInfo::OnCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	DefWindowProc();
	switch(HIWORD(wParam))
	{
	case BN_CLICKED: 
		if(LOWORD(wParam)-IDC_CHANNEL0>=0 &&LOWORD(wParam)-IDC_CHANNEL0<16)
		{
			Channel[LOWORD(wParam)-IDC_CHANNEL0]=IsDlgButtonChecked(LOWORD(wParam));
			::InvalidateRgn(GetParent(),NULL,FALSE);
			::UpdateWindow(GetParent());
		}
		break;
	}

	return 0;
}
