// LAInfo.h : interface of the CLAinfo class
//
/////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once
#include "resource.h"

class CLAInfo : public CDialogImpl<CLAInfo>,public CWinDataExchange<CLAInfo>
{
public:
	bool	Channel[16];
	double	Mhz[16];
	enum { IDD = IDD_LAINFO };

	BEGIN_MSG_MAP(CLAInfo)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_PARENTNOTIFY, OnParentNotify)
		MESSAGE_HANDLER(WM_NOTIFY, OnNotify)
		MESSAGE_HANDLER(WM_COMMAND, OnCommand)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CLAInfo)
		DDX_CHECK(IDC_CHANNEL0,Channel[0]);
		DDX_CHECK(IDC_CHANNEL1,Channel[1]);
		DDX_CHECK(IDC_CHANNEL2,Channel[2]);
		DDX_CHECK(IDC_CHANNEL3,Channel[3]);
		DDX_CHECK(IDC_CHANNEL4,Channel[4]);
		DDX_CHECK(IDC_CHANNEL5,Channel[5]);
		DDX_CHECK(IDC_CHANNEL6,Channel[6]);
		DDX_CHECK(IDC_CHANNEL7,Channel[7]);
		DDX_CHECK(IDC_CHANNEL8,Channel[8]);
		DDX_CHECK(IDC_CHANNEL9,Channel[9]);
		DDX_CHECK(IDC_CHANNELA,Channel[10]);
		DDX_CHECK(IDC_CHANNELB,Channel[11]);
		DDX_CHECK(IDC_CHANNELC,Channel[12]);
		DDX_CHECK(IDC_CHANNELD,Channel[13]);
		DDX_CHECK(IDC_CHANNELE,Channel[14]);
		DDX_CHECK(IDC_CHANNELF,Channel[15]);
	END_DDX_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnParentNotify(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnNotify(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnCommand(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
//	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	CLAInfo(void);
	~CLAInfo(void);
};
