// LogicAnalyzer.cpp : main source file for LogicAnalyzer.exe
//
/////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdafx.h"

#include "resource.h"

#include "LogicAnalyzerView.h"
#include "aboutdlg.h"
#include "MainFrm.h"

CAppModule _Module;

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
	CMainFrame wndMain;

	TiXmlDocument * pXmlDoc=new TiXmlDocument;
	TiXmlHandle docHandle(pXmlDoc);
	if(pXmlDoc->LoadFile("LASave.xml"))
	{
		TiXmlElement * pWindowpos = docHandle.FirstChild("LogicAnalyzer").FirstChild("Windowpos").ToElement();
		if(pWindowpos)
		{
			pWindowpos->QueryIntAttribute("Left",(int*)&wndMain.Windowpos.left);
			pWindowpos->QueryIntAttribute("Right",(int*)&wndMain.Windowpos.right);
			pWindowpos->QueryIntAttribute("Top",(int*)&wndMain.Windowpos.top);
			pWindowpos->QueryIntAttribute("Bottom",(int*)&wndMain.Windowpos.bottom);
		}
		TiXmlElement * pChannels = docHandle.FirstChild("LogicAnalyzer").FirstChild("Channels").ToElement();
		if(pChannels)
		{
			int b;
			pChannels->QueryIntAttribute("Channel0",&b);wndMain.m_view.InfoDlg.Channel[0]=(b==1);
			pChannels->QueryIntAttribute("Channel1",&b);wndMain.m_view.InfoDlg.Channel[1]=(b==1);
			pChannels->QueryIntAttribute("Channel2",&b);wndMain.m_view.InfoDlg.Channel[2]=(b==1);
			pChannels->QueryIntAttribute("Channel3",&b);wndMain.m_view.InfoDlg.Channel[3]=(b==1);
			pChannels->QueryIntAttribute("Channel4",&b);wndMain.m_view.InfoDlg.Channel[4]=(b==1);
			pChannels->QueryIntAttribute("Channel5",&b);wndMain.m_view.InfoDlg.Channel[5]=(b==1);
			pChannels->QueryIntAttribute("Channel6",&b);wndMain.m_view.InfoDlg.Channel[6]=(b==1);
			pChannels->QueryIntAttribute("Channel7",&b);wndMain.m_view.InfoDlg.Channel[7]=(b==1);
			pChannels->QueryIntAttribute("Channel8",&b);wndMain.m_view.InfoDlg.Channel[8]=(b==1);
			pChannels->QueryIntAttribute("Channel9",&b);wndMain.m_view.InfoDlg.Channel[9]=(b==1);
			pChannels->QueryIntAttribute("ChannelA",&b);wndMain.m_view.InfoDlg.Channel[10]=(b==1);
			pChannels->QueryIntAttribute("ChannelB",&b);wndMain.m_view.InfoDlg.Channel[11]=(b==1);
			pChannels->QueryIntAttribute("ChannelC",&b);wndMain.m_view.InfoDlg.Channel[12]=(b==1);
			pChannels->QueryIntAttribute("ChannelD",&b);wndMain.m_view.InfoDlg.Channel[13]=(b==1);
			pChannels->QueryIntAttribute("ChannelE",&b);wndMain.m_view.InfoDlg.Channel[14]=(b==1);
			pChannels->QueryIntAttribute("ChannelF",&b);wndMain.m_view.InfoDlg.Channel[15]=(b==1);
		}
		TiXmlElement * pTrigger = docHandle.FirstChild("LogicAnalyzer").FirstChild("Trigger").ToElement();
		if(pTrigger)
		{
			int b;
			pTrigger->QueryIntAttribute("Clock",&b);wndMain.m_view.Clock=b;
			pTrigger->QueryIntAttribute("PreAmble",&b);wndMain.m_view.PreAmble=b;
			pTrigger->QueryIntAttribute("Mask0",&b);wndMain.m_view.Mask[0]=b;
			pTrigger->QueryIntAttribute("Value0",&b);wndMain.m_view.Value[0]=b;
			pTrigger->QueryIntAttribute("StartSampling0",&b);wndMain.m_view.StartSampling[0]=b;
			pTrigger->QueryIntAttribute("AnyChange0",&b);wndMain.m_view.AnyChange[0]=b;
			pTrigger->QueryIntAttribute("Mask1",&b);wndMain.m_view.Mask[1]=b;
			pTrigger->QueryIntAttribute("Value1",&b);wndMain.m_view.Value[1]=b;
			pTrigger->QueryIntAttribute("StartSampling1",&b);wndMain.m_view.StartSampling[1]=b;
			pTrigger->QueryIntAttribute("AnyChange1",&b);wndMain.m_view.AnyChange[1]=b;
			pTrigger->QueryIntAttribute("Mask2",&b);wndMain.m_view.Mask[2]=b;
			pTrigger->QueryIntAttribute("Value2",&b);wndMain.m_view.Value[2]=b;
			pTrigger->QueryIntAttribute("StartSampling2",&b);wndMain.m_view.StartSampling[2]=b;
			pTrigger->QueryIntAttribute("AnyChange2",&b);wndMain.m_view.AnyChange[2]=b;
			pTrigger->QueryIntAttribute("Mask3",&b);wndMain.m_view.Mask[3]=b;
			pTrigger->QueryIntAttribute("Value3",&b);wndMain.m_view.Value[3]=b;
			pTrigger->QueryIntAttribute("StartSampling3",&b);wndMain.m_view.StartSampling[3]=b;
			pTrigger->QueryIntAttribute("AnyChange3",&b);wndMain.m_view.AnyChange[3]=b;
		}

	}
	delete pXmlDoc;

	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);


	if(wndMain.CreateEx(NULL,wndMain.Windowpos) == NULL)
	{
		ATLTRACE(_T("Main window creation failed!\n"));
		return 0;
	}
	
	wndMain.SetWindowText(_T("Simple 16 Channel Logic analyzer, capable of 100Mhz Sampling"));
	wndMain.ShowWindow(nCmdShow);

	int nRet = theLoop.Run();

	pXmlDoc=new TiXmlDocument;
 	TiXmlDeclaration* decl = new TiXmlDeclaration( "1.0", "", "" );  
	pXmlDoc->LinkEndChild( decl );  
 	TiXmlElement * pRoot = new TiXmlElement("LogicAnalyzer");
	pXmlDoc->LinkEndChild(pRoot);
	TiXmlElement * pWindowpos= new TiXmlElement("Windowpos");
	pRoot->LinkEndChild(pWindowpos);
	pWindowpos->SetAttribute("Left",wndMain.Windowpos.left);
	pWindowpos->SetAttribute("Right",wndMain.Windowpos.right);
	pWindowpos->SetAttribute("Top",wndMain.Windowpos.top);
	pWindowpos->SetAttribute("Bottom",wndMain.Windowpos.bottom);

	TiXmlElement * pChannels = new TiXmlElement("Channels");
	pRoot->LinkEndChild(pChannels);
	pChannels->SetAttribute("Channel0",wndMain.m_view.InfoDlg.Channel[0]);
	pChannels->SetAttribute("Channel1",wndMain.m_view.InfoDlg.Channel[1]);
	pChannels->SetAttribute("Channel2",wndMain.m_view.InfoDlg.Channel[2]);
	pChannels->SetAttribute("Channel3",wndMain.m_view.InfoDlg.Channel[3]);
	pChannels->SetAttribute("Channel4",wndMain.m_view.InfoDlg.Channel[4]);
	pChannels->SetAttribute("Channel5",wndMain.m_view.InfoDlg.Channel[5]);
	pChannels->SetAttribute("Channel6",wndMain.m_view.InfoDlg.Channel[6]);
	pChannels->SetAttribute("Channel7",wndMain.m_view.InfoDlg.Channel[7]);
	pChannels->SetAttribute("Channel8",wndMain.m_view.InfoDlg.Channel[8]);
	pChannels->SetAttribute("Channel9",wndMain.m_view.InfoDlg.Channel[9]);
	pChannels->SetAttribute("ChannelA",wndMain.m_view.InfoDlg.Channel[10]);
	pChannels->SetAttribute("ChannelB",wndMain.m_view.InfoDlg.Channel[11]);
	pChannels->SetAttribute("ChannelC",wndMain.m_view.InfoDlg.Channel[12]);
	pChannels->SetAttribute("ChannelD",wndMain.m_view.InfoDlg.Channel[13]);
	pChannels->SetAttribute("ChannelE",wndMain.m_view.InfoDlg.Channel[14]);
	pChannels->SetAttribute("ChannelF",wndMain.m_view.InfoDlg.Channel[15]);

	TiXmlElement * pTrigger = new TiXmlElement("Trigger");
	pRoot->LinkEndChild(pTrigger);
	pTrigger->SetAttribute("Clock",wndMain.m_view.Clock);
	pTrigger->SetAttribute("PreAmble",wndMain.m_view.PreAmble);
	pTrigger->SetAttribute("Mask0",wndMain.m_view.Mask[0]);
	pTrigger->SetAttribute("Value0",wndMain.m_view.Value[0]);
	pTrigger->SetAttribute("StartSampling0",wndMain.m_view.StartSampling[0]);
	pTrigger->SetAttribute("AnyChange0",wndMain.m_view.AnyChange[0]);
	pTrigger->SetAttribute("Mask1",wndMain.m_view.Mask[1]);
	pTrigger->SetAttribute("Value1",wndMain.m_view.Value[1]);
	pTrigger->SetAttribute("StartSampling1",wndMain.m_view.StartSampling[1]);
	pTrigger->SetAttribute("AnyChange1",wndMain.m_view.AnyChange[1]);
	pTrigger->SetAttribute("Mask2",wndMain.m_view.Mask[20]);
	pTrigger->SetAttribute("Value2",wndMain.m_view.Value[2]);
	pTrigger->SetAttribute("StartSampling2",wndMain.m_view.StartSampling[2]);
	pTrigger->SetAttribute("AnyChange2",wndMain.m_view.AnyChange[2]);
	pTrigger->SetAttribute("Mask3",wndMain.m_view.Mask[3]);
	pTrigger->SetAttribute("Value3",wndMain.m_view.Value[3]);
	pTrigger->SetAttribute("StartSampling3",wndMain.m_view.StartSampling[3]);
	pTrigger->SetAttribute("AnyChange3",wndMain.m_view.AnyChange[3]);


	pXmlDoc->SaveFile("LASave.xml");

	_Module.RemoveMessageLoop();
	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

	// this resolves ATL window thunking problem when Microsoft Layer for Unicode (MSLU) is used
	::DefWindowProc(NULL, 0, 0, 0L);

	AtlInitCommonControls(ICC_COOL_CLASSES | ICC_BAR_CLASSES);	// add flags to support other controls

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

	return nRet;
}
