// Settrigger.h : implmentation of the CSetTrigger class
//
/////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "StdAfx.h"
#include "resource.h"
#include "SetTrigger.h"

CSetTrigger::CSetTrigger(void)
{
}

CSetTrigger::~CSetTrigger(void)
{
}

LRESULT CSetTrigger::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	DoDataExchange(FALSE);

	::SetWindowText(GetDlgItem(IDC_TRIGGERTXT),_T("Preamble is the number of clock pulses which are displayed before the trigger point. \012\012")
		 _T("The Clock value is the number of pulses of the 200mhz internal clock that is used to flip-flop ")
		 _T("the sample clock.\012So a value of 1 gives a sample clock of 100mhz, a value of 2=50mhz, 3=33mhz, so ")
		 _T("200mhz/(2*the value of the clock variable). \012\012")
		 _T("The Trigger mask is used to indicate which trigger value bits are relevant. The triggering is done when ")
		 _T("the relevant trigger bits equal the corresponding channel value(s). \012\012")
		 _T("The Any switch will let you trigger on any change on the channels indicated by the mask."));
	TCHAR buf[100];_stprintf(buf,_T("%3.2fMhz"),200./(2*Clock));
	::SetWindowText(GetDlgItem(IDC_CLOCKMHZ),buf);
	
	for(int i=0;i<4;++i)
	{
		Tabs.Trg[i]->SetMask(Mask[i]);
		Tabs.Trg[i]->SetValue(Value[i]);
		Tabs.Trg[i]->SetStartSampling(StartSampling[i]);
		Tabs.Trg[i]->SetAnyChange(AnyChange[i]);
	}
	Tabs.Trg[3]->SetStartSampling(1);

	CenterWindow(GetParent());
	Tabs.SubclassWindow(GetDlgItem(IDC_TAB));

	Tabs.InsertItem(0,_T("Step 1"));
	Tabs.InsertItem(1,_T("Step 2"));
	Tabs.InsertItem(2,_T("Step 3"));
	Tabs.InsertItem(3,_T("Step 4"));

	Tabs.Init();

	return 0;
}
LRESULT CSetTrigger::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	DoDataExchange(TRUE);
	for(int i=0;i<4;++i)
	{
		Tabs.Trg[i]->DoDataExchange(TRUE);
		Mask[i]=Tabs.Trg[i]->GetMask();
		Value[i]=Tabs.Trg[i]->GetValue();
		StartSampling[i]=Tabs.Trg[i]->GetStartSampling();
		AnyChange[i]=Tabs.Trg[i]->GetAnyChange();
	}

	Tabs.Destroy();
	Tabs.UnsubclassWindow();
	EndDialog(wID);
	return 0;
}
