// Settrigger.h : interface of the CSetTrigger class
//
/////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once
#include "TriggerTabs.h"

class CSetTrigger : public CDialogImpl<CSetTrigger>,public CWinDataExchange<CSetTrigger>
{
	CTriggerTabs	Tabs;
public:
	UINT	Clock;
	UINT	PreAmble;
	WORD	Mask[4],Value[4];
	bool	StartSampling[4];
	bool	AnyChange[4];

	enum { IDD = IDD_SETTRIGGER };

	BEGIN_MSG_MAP(CSetTrigger)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDC_SETTRIGGER, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CTrigger>)
		DDX_UINT_RANGE(IDC_CLOCK, (UINT&)Clock,(UINT)1,(UINT)32)
		DDX_UINT(IDC_PREAMBLE, PreAmble)
	END_DDX_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	CSetTrigger(void);
	~CSetTrigger(void);
};
