// Trigger.h : implementation of the CTrigger class
//
/////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "StdAfx.h"
#include "resource.h"
#include "Trigger.h"

CTrigger::CTrigger(void)
{
}

CTrigger::~CTrigger(void)
{
}

LRESULT CTrigger::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	DoDataExchange(FALSE);

	return 0;
}
LRESULT CTrigger::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	return 0;
}
void CTrigger::SetMask(WORD w)
{
	for(int i=0;i<16;++i)
		Mask[i]=(w>>i)&1;
}
WORD CTrigger::GetMask()
{
WORD r=0;
	for(int i=0;i<16;++i)
		r+=Mask[i]<<i;
	return r;
}
void CTrigger::SetValue(WORD w)
{
	for(int i=0;i<16;++i)
		Value[i]=(w>>i)&1;
}
WORD CTrigger::GetValue()
{
WORD r=0;
	for(int i=0;i<16;++i)
		r+=Value[i]<<i;
	return r;
}
