// Trigger.h : interface of the CTrigger class
//
/////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

class CTrigger : public CDialogImpl<CTrigger>,public CWinDataExchange<CTrigger>
{
	bool Mask[16],Value[16];
	bool StartSampling;
	bool AnyChange;
public:
	enum { IDD = IDD_TRIGGER };

	BEGIN_MSG_MAP(CTrigger)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CTrigger>)
//		DDX_TEXT(<dlg resource id>,<string variable>)
//		DDX_TEXT_LEN(<dlg resource id2>,<string variable2>, <max text length>)
		DDX_CHECK(IDC_MASK0,Mask[0]);
		DDX_CHECK(IDC_MASK1,Mask[1]);
		DDX_CHECK(IDC_MASK2,Mask[2]);
		DDX_CHECK(IDC_MASK3,Mask[3]);
		DDX_CHECK(IDC_MASK4,Mask[4]);
		DDX_CHECK(IDC_MASK5,Mask[5]);
		DDX_CHECK(IDC_MASK6,Mask[6]);
		DDX_CHECK(IDC_MASK7,Mask[7]);
		DDX_CHECK(IDC_MASK8,Mask[8]);
		DDX_CHECK(IDC_MASK9,Mask[9]);
		DDX_CHECK(IDC_MASKA,Mask[10]);
		DDX_CHECK(IDC_MASKB,Mask[11]);
		DDX_CHECK(IDC_MASKC,Mask[12]);
		DDX_CHECK(IDC_MASKD,Mask[13]);
		DDX_CHECK(IDC_MASKE,Mask[14]);
		DDX_CHECK(IDC_MASKF,Mask[15]);
		DDX_CHECK(IDC_VALUE0,Value[0]);
		DDX_CHECK(IDC_VALUE1,Value[1]);
		DDX_CHECK(IDC_VALUE2,Value[2]);
		DDX_CHECK(IDC_VALUE3,Value[3]);
		DDX_CHECK(IDC_VALUE4,Value[4]);
		DDX_CHECK(IDC_VALUE5,Value[5]);
		DDX_CHECK(IDC_VALUE6,Value[6]);
		DDX_CHECK(IDC_VALUE7,Value[7]);
		DDX_CHECK(IDC_VALUE8,Value[8]);
		DDX_CHECK(IDC_VALUE9,Value[9]);
		DDX_CHECK(IDC_VALUEA,Value[10]);
		DDX_CHECK(IDC_VALUEB,Value[11]);
		DDX_CHECK(IDC_VALUEC,Value[12]);
		DDX_CHECK(IDC_VALUED,Value[13]);
		DDX_CHECK(IDC_VALUEE,Value[14]);
		DDX_CHECK(IDC_VALUEF,Value[15]);
		DDX_CHECK(IDC_STARTSAMPLING,StartSampling);
		DDX_CHECK(IDC_ANYCHANGE,AnyChange);
	END_DDX_MAP()


// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	CTrigger(void);
	~CTrigger(void);

	void SetMask(WORD w);
	WORD GetMask();
	void SetValue(WORD w);
	WORD GetValue();
	void SetStartSampling(bool v){StartSampling=v;}
	bool GetStartSampling(){return StartSampling;}
	void SetAnyChange(bool v){AnyChange=v;}
	bool GetAnyChange(){return AnyChange;}
};
