// TriggerTabs.cpp : implmentation of the CTriggerTabs class
//
/////////////////////////////////////////////////////////////////////////////
/*
	Copyright: D.A. Heitman
    This file is part of a simple logic analyzer.

    This logic analyzer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    logic analyzer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this logic analyzer.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "StdAfx.h"
#include "resource.h"
#include "TriggerTabs.h"

CTriggerTabs::CTriggerTabs(void)
{
	Trg[0]=new CTrigger();
	Trg[1]=new CTrigger();
	Trg[2]=new CTrigger();
	Trg[3]=new CTrigger();

}


CTriggerTabs::~CTriggerTabs(void)
{
	delete Trg[0];
	delete Trg[1];
	delete Trg[2];
	delete Trg[3];
}
void CTriggerTabs::Init()
{
	Trg[0]->Create(m_hWnd,0);
	Trg[1]->Create(m_hWnd,1);
	Trg[2]->Create(m_hWnd,2);
	Trg[3]->Create(m_hWnd,3);

	Trg[0]->ShowWindow(SW_SHOW);
	Trg[1]->ShowWindow(SW_HIDE);
	Trg[2]->ShowWindow(SW_HIDE);
	Trg[3]->ShowWindow(SW_HIDE);
	::EnableWindow(Trg[3]->GetDlgItem(IDC_STARTSAMPLING),false);

	curTab=0;
}
void CTriggerTabs::Destroy()
{
	Trg[0]->DestroyWindow();
	Trg[1]->DestroyWindow();
	Trg[2]->DestroyWindow();
	Trg[3]->DestroyWindow();
}
LRESULT CTriggerTabs::OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	DefWindowProc(uMsg,wParam,lParam);
	if(curTab!=GetCurFocus())
	{
		Trg[curTab]->ShowWindow(SW_HIDE);
		curTab=GetCurFocus();
		Trg[curTab]->ShowWindow(SW_SHOW);
		Trg[curTab]->SetFocus();
	}

	return 0;
}
